// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See Vsecret_impl.h for the primary calling header

#include "Vsecret_impl__pch.h"
#include "Vsecret_impl_PSCv8Z.h"

void Vsecret_impl_PSCv8Z__PSPWIs(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PSPWIs\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
}

void Vsecret_impl_PSCv8Z__PSvWNS(Vsecret_impl_PSCv8Z* vlSelf);

void Vsecret_impl_PSCv8Z__PSopFU(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PSopFU\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Body
    if ((1ULL & vlSelfRef.PSAAhz.word(0U))) {
        Vsecret_impl_PSCv8Z__PSvWNS(vlSelf);
    }
}

VL_INLINE_OPT void Vsecret_impl_PSCv8Z__PSvWNS(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PSvWNS\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    IData PSDCS3;
    PSDCS3 = 0;
    // Body
    PSDCS3 = vlSelfRef.PSS4nF;
    PSDCS3 = (vlSelfRef.PSS4nF + vlSelfRef.a);
    vlSelfRef.x = ((0xaU < vlSelfRef.PSS4nF) ? vlSelfRef.b
                    : ((IData)(9U) + (vlSelfRef.a + vlSelfRef.b)));
    vlSelfRef.PSS4nF = PSDCS3;
}

void Vsecret_impl_PSCv8Z__PSeXzd(Vsecret_impl_PSCv8Z* vlSelf);

bool Vsecret_impl_PSCv8Z__PS0osn(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PS0osn\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    VlTriggerVec<1> PSmTrK;
    CData PS0Qgn;
    // Body
    Vsecret_impl_PSCv8Z__PSeXzd(vlSelf);
    PS0Qgn = vlSelfRef.PSe19l.any();
    if (PS0Qgn) {
        PSmTrK.andNot(vlSelfRef.PSe19l, vlSelfRef.PSAAhz);
        vlSelfRef.PSAAhz.thisOr(vlSelfRef.PSe19l);
        Vsecret_impl_PSCv8Z__PSPWIs(vlSelf);
    }
    return (PS0Qgn);
}

bool Vsecret_impl_PSCv8Z__PSC1Pf(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PSC1Pf\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    CData PSP3A0;
    // Body
    PSP3A0 = vlSelfRef.PSAAhz.any();
    if (PSP3A0) {
        Vsecret_impl_PSCv8Z__PSopFU(vlSelf);
        vlSelfRef.PSAAhz.clear();
    }
    return (PSP3A0);
}

#ifdef VL_DEBUG
VL_ATTR_COLD void Vsecret_impl_PSCv8Z__PSuMbm(Vsecret_impl_PSCv8Z* vlSelf);
#endif  // VL_DEBUG
#ifdef VL_DEBUG
VL_ATTR_COLD void Vsecret_impl_PSCv8Z__PSltzR(Vsecret_impl_PSCv8Z* vlSelf);
#endif  // VL_DEBUG

void Vsecret_impl_PSCv8Z__PSmrkA(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PSmrkA\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Init
    IData PSDo8K;
    CData PS7tmY;
    // Body
    PSDo8K = 0U;
    PS7tmY = 1U;
    while (PS7tmY) {
        if (VL_UNLIKELY(((0x64U < PSDo8K)))) {
#ifdef VL_DEBUG
            Vsecret_impl_PSCv8Z__PSuMbm(vlSelf);
#endif
            VL_FATAL_MT("PSIwM8", 10, "", "NBA region did not converge.");
        }
        PSDo8K = ((IData)(1U) + PSDo8K);
        PS7tmY = 0U;
        vlSelfRef.PSiDLE = 0U;
        vlSelfRef.PSXbhG = 1U;
        while (vlSelfRef.PSXbhG) {
            if (VL_UNLIKELY(((0x64U < vlSelfRef.PSiDLE)))) {
#ifdef VL_DEBUG
                Vsecret_impl_PSCv8Z__PSltzR(vlSelf);
#endif
                VL_FATAL_MT("PSIwM8", 10, "", "Active region did not converge.");
            }
            vlSelfRef.PSiDLE = ((IData)(1U) + vlSelfRef.PSiDLE);
            vlSelfRef.PSXbhG = 0U;
            if (Vsecret_impl_PSCv8Z__PS0osn(vlSelf)) {
                vlSelfRef.PSXbhG = 1U;
            }
        }
        if (Vsecret_impl_PSCv8Z__PSC1Pf(vlSelf)) {
            PS7tmY = 1U;
        }
    }
}

#ifdef VL_DEBUG
void Vsecret_impl_PSCv8Z__PS6uOK(Vsecret_impl_PSCv8Z* vlSelf) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    Vsecret_impl_PSCv8Z__PS6uOK\n"); );
    Vsecret_impl_PSAObR* const __restrict vlSymsp VL_ATTR_UNUSED = vlSelf->vlSymsp;
    auto& vlSelfRef = std::ref(*vlSelf).get();
    // Body
    if (VL_UNLIKELY(((vlSelfRef.clk & 0xfeU)))) {
        Verilated::overWidthError("clk");}
}
#endif  // VL_DEBUG
